/************************************************************************

    JOYCE v2.1.6 - Amstrad PCW emulator

    Copyright (C) 1996, 2004  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#ifdef HAVE_SDL_SDL_GFXPRIMITIVES_H
class PcwGSX : public PcwSdlTerm
{
public:
	PcwGSX(PcwSystem *s);
	virtual ~PcwGSX();

	void command(word rde);

protected:
        virtual bool parseNode(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
        virtual bool storeNode(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
	virtual PcwTerminal& operator<<(unsigned char c);
        virtual void setForeground(byte r, byte g, byte b);
        virtual void setBackground(byte r, byte g, byte b);
	virtual void getColour(Uint32 *col, word array, word off);
	virtual void setColour(Uint32 *col);

	word getWord(word addr);
	word getArray(word addr, word idx);
	void putArray(word addr, word idx, word value);
	void initPalette();
	void letterPixel(int xb, int yb, int x, int y, Uint32 tcol);
	void getPtsin();
	void gsxPolyLine(int npts, Uint32 colour);
	void gsxLine(int x1, int y1, int x2, int y2, Uint32 colour);
	void setColourIndex();
	void setLineStyle();

	// GSX functions
	void openWorkstation();
	void closeWorkstation();
	void clearPicture();
	void updateWorkstation();
	void drawPolyline();

	void setWriteMode();
private:
	word gsxpb, ctrl, intin, intout, ptsin, ptsout;
	int oldtype;
	int line_size, marker_size, text_size;
	word request_col[128][3];
	int m_colourMap[128];

	Uint32 line_colour, line_style, marker_colour, marker_style,
           text_style, text_colour, fill_colour, fill_style, fill_index,
	              locator_mode;

	Uint32 gsxbg, gsxfg_and, gsxfg_or;
	int text_sin, text_cos;
	int points_in[75][2];

	PcwTerminal *m_oldTerm;
	SDL_Surface *m_surface;
	PcwSystem *m_sys;
};
#endif
